package jp.deadend.noname.howmm

import java.io.File
import java.text.SimpleDateFormat

class GrepItem(val file: File, val linenumber: Int = 0, val text: String = "") {
    var reminder: ReminderItem? = null
        private set

    fun updateReminder(sdf1: SimpleDateFormat, sdf2: SimpleDateFormat, useOrig: Boolean) {
        reminder = ReminderItem.createInstance(this, sdf1, sdf2, useOrig)
    }

    // reminderはequals()でもhashCode()でも使わない
    override fun equals(other: Any?): Boolean {
        if (other !is GrepItem) return false
        return (other.file == file
                && other.linenumber == linenumber
                && other.text == text)
    }

    override fun hashCode(): Int {
        return (file.hashCode() * 31 + linenumber * 31 + text.hashCode() * 31)
    }
}
