package jp.deadend.noname.howmm

import android.graphics.Canvas
import android.graphics.Paint
import android.text.Layout
import android.text.Spanned
import android.text.TextPaint
import android.text.style.LeadingMarginSpan
import android.text.style.MetricAffectingSpan

class HeadedSpan(private val mHeader: String, private val mGapWidth: Float, private val mHeaderGapWidth: Float) : LeadingMarginSpan, MetricAffectingSpan() {
    private var mHeaderWidth = 0f

    override fun getLeadingMargin(first: Boolean) = (mGapWidth + mHeaderWidth + mHeaderGapWidth).toInt()

    override fun drawLeadingMargin(c: Canvas, p: Paint, x: Int, dir: Int,
                                   top: Int, baseline: Int, bottom: Int,
                                   text: CharSequence, start: Int, end: Int,
                                   first: Boolean, l: Layout) {
        if ((text as Spanned).getSpanStart(this) == start) {
            val style = p.style

            p.isFakeBoldText = true
            c.drawText(mHeader, x + mGapWidth - mHeaderGapWidth, baseline.toFloat(), p)
            mHeaderWidth = p.measureText(mHeader)
            p.isFakeBoldText = false

            p.style = style
        }
    }

    override fun updateMeasureState(textPaint: TextPaint) {
        textPaint.textScaleX = 1.04f // 右が切れるのでworkaround
    }

    override fun updateDrawState(tp: TextPaint?) {}
}
