package jp.deadend.noname.howmm

import android.graphics.Canvas
import android.graphics.Paint
import android.graphics.Path
import android.graphics.Path.Direction
import android.text.Layout
import android.text.Spanned
import android.text.style.LeadingMarginSpan

internal class ItemSpan(private val mGapWidth: Float, private val mRadius: Float) : LeadingMarginSpan {
    private var mBulletPath: Path? = null

    override fun getLeadingMargin(first: Boolean): Int = (mGapWidth + 4 * mRadius).toInt()

    override fun drawLeadingMargin(c: Canvas, p: Paint, x: Int, dir: Int,
                                   top: Int, baseline: Int, bottom: Int,
                                   text: CharSequence, start: Int, end: Int,
                                   first: Boolean, l: Layout) {
        if ((text as Spanned).getSpanStart(this) == start) {
            val style = p.style
            p.style = Paint.Style.FILL

            val xPosition = mRadius + x + mGapWidth
            val yPosition = (top + bottom) / 2.0f

            if (c.isHardwareAccelerated) {
                if (mBulletPath == null) {
                    mBulletPath = Path().apply { addCircle(0.0f, 0.0f, mRadius, Direction.CW) }
                }

                c.save()
                c.translate(xPosition, yPosition)
                c.drawPath(mBulletPath!!, p)
                c.restore()
            } else {
                c.drawCircle(xPosition, yPosition, mRadius, p)
            }

            p.style = style
        }
    }
}
