package jp.deadend.noname.howmm

import android.app.Dialog
import android.os.Bundle
import androidx.fragment.app.DialogFragment
import androidx.appcompat.app.AlertDialog

class StringChoiceDialogFragment : DialogFragment() {
    private var mListener: Listener? = null

    interface Listener {
        fun onClick(result: String)
    }

    fun setListener(listener: Listener) {
        this.mListener = listener
    }

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        val args = arguments
        val items = args?.getStringArray("items")
        return AlertDialog.Builder(requireContext())
                .setTitle(args?.getString("title"))
                .setItems(items) { _, which ->
                    mListener?.onClick(items?.get(which) ?: "")
                    dismiss()
                }
                .setNegativeButton(android.R.string.cancel) { _, _ -> dismiss() }
                .setCancelable(true)
                .create()
    }

    companion object {
        fun newInstance(title: String, items: Array<String>): StringChoiceDialogFragment {
            val frag = StringChoiceDialogFragment()
            val args = Bundle()
            args.putString("title", title)
            args.putStringArray("items", items)
            frag.arguments = args
            return frag
        }
    }
}
